=== modified file 'blocks/helpdesk/lang/en_utf8/block_helpdesk.php'
--- blocks/helpdesk/lang/en_utf8/block_helpdesk.php	2010-08-09 16:58:24 +0000
+++ blocks/helpdesk/lang/en_utf8/block_helpdesk.php	2010-08-17 19:08:34 +0000
@@ -30,44 +30,44 @@
 $string['helpdesk:ask']         = 'Help Desk Asker';
 $string['block/helpdesk:ask']   = $string['helpdesk:ask'];
 $string['helpdesk']             = 'Help Desk';
-$string['ticketinfo']           = 'Ticket Overview';
-$string['ticketid']             = 'Ticket ID';
+$string['ticketinfo']           = 'Question Overview';
+$string['ticketid']             = 'Question ID';
 $string['submittedby']          = 'Submitted By';
 $string['timecreated']          = 'Created On';
 $string['status']               = 'Status';
-$string['specifics']            = 'Specific Ticket Details';
+$string['specifics']            = 'Specific Question Details';
 $string['summary']              = 'Summary';
 $string['detail']               = 'Issue Details';
-$string['ticketupdates']        = 'Ticket History';
+$string['ticketupdates']        = 'Question History';
 $string['user']                 = 'User';
 $string['date']                 = 'Date';
 $string['comment']              = 'Comment';
-$string['updateticket']         = 'Update Ticket';
+$string['updateticket']         = 'Update Question';
 $string['updatestatus']         = 'Update Status';
-$string['update']               = 'Ticket Update';
+$string['update']               = 'Question Update';
 $string['status_comment']       = 'Comment';
 $string['status_progress']      = 'In Progress';
 $string['status_close']         = 'Closed';
-$string['submitticket']         = 'Submit Ticket';
-$string['ticketview']           = 'View Ticket';
+$string['submitticket']         = 'Submit Question';
+$string['ticketview']           = 'View Question';
 $string['timemodified']         = 'Updated On';
-$string['newticketform']        = 'New Ticket';
-$string['newticketmsg']         = 'Your ticket has been successfully submitted.';
-$string['newticket']            = 'New Ticket';
-$string['viewalltickets']       = 'View all Tickets';
-$string['submitnewticket']      = 'Submit a new ticket';
-$string['mytickets']            = 'My Submitted Tickets';
+$string['newticketform']        = 'New Question';
+$string['newticketmsg']         = 'Your question has been successfully submitted.';
+$string['newticket']            = 'New Question';
+$string['viewalltickets']       = 'View all Questions';
+$string['submitnewticket']      = 'Submit a new question';
+$string['mytickets']            = 'My Submitted Questions';
 $string['status_new']           = 'New';
 $string['status_reopen']        = 'Reopen';
-$string['updateadded']          = 'Update added to ticket';
-$string['backtoticket']         = 'Return to ticket';
+$string['updateadded']          = 'Update added to question';
+$string['backtoticket']         = 'Return to question';
 $string['updates']              = 'Update History';
-$string['ticketviewer']         = 'Ticket Viewer';
-$string['noupdates']            = 'This ticket has no updates.';
+$string['ticketviewer']         = 'Question Viewer';
+$string['noupdates']            = 'This question has no updates.';
 $string['addtag']               = 'Add New Tag';
 $string['tags']                 = 'Tags';
-$string['ticket']               = 'Ticket';
-$string['tickettag']            = 'Ticket Tagging';
+$string['ticket']               = 'Question';
+$string['tickettag']            = 'Question Tagging';
 $string['tagname']              = 'Name';
 $string['tagcontent']           = 'Tag Content';
 $string['extradetailtags']      = 'Extra Detail Tags';
@@ -76,31 +76,31 @@
 $string['removetag']            = 'Remove Tag';
 $string['tagremoved']           = 'Tag removed.';
 $string['tagadded']             = 'Tag added.';
-$string['missingticketparam']   = 'Missing ticket ID parameter.';
+$string['missingticketparam']   = 'Missing question ID parameter.';
 $string['connotaddassignment']  = 'Unable to add assignment.';
 $string['assignments']          = 'Assignments';
-$string['selectusertoassign']   = 'Select a user to assign to the ticket.';
+$string['selectusertoassign']   = 'Select a user to assign to the question.';
 $string['assignmentadded']      = 'Assignment added.';
-$string['returntoticket']       = 'Return to ticket.';
+$string['returntoticket']       = 'Return to question.';
 $string['assignedusers']        = 'Assigned Users';
 $string['noneassigned']         = 'No users are assigned.';
 $string['assignuser']           = 'Assign a user';
-$string['isalreadyassigned']    = 'is already assigned to this ticket.';
-$string['viewticket']           = 'View Ticket';
-$string['notags']               = 'This ticket has no tags.';
-$string['changerelation']       = 'Relation Options';
-$string['usertickets']          = 'User Tickets';
-$string['ticketsassigned']      = 'Assigned Tickets';
-$string['newtickets']           = 'New Tickets';
-$string['noassigntickets']      = 'Unassigned Tickets';
+$string['isalreadyassigned']    = 'is already assigned to this question.';
+$string['viewticket']           = 'View Question';
+$string['notags']               = 'This question has no tags.';
+$string['changerelation']       = 'Short-cuts to question groups';
+$string['usertickets']          = 'User Questions';
+$string['ticketsassigned']      = 'Assigned Questions';
+$string['newtickets']           = 'New Questions';
+$string['noassigntickets']      = 'Unassigned Questions';
 $string['lastupdated']          = 'Last Updated';
 $string['nextpage']             = 'Next Page';
 $string['previouspage']         = 'Previous Page';
 $string['youarea']              = 'You are a';
 $string['warning_getandrequire']= 'A function call is passing a parameter when one is not expected. This is a software bug.';
-$string['noticketstodisplay']   = 'No tickets to display.';
-$string['wasassigned']          = 'was assigned to this ticket.';
-$string['wasunassigned']        = 'was unassigned from the ticket.';
+$string['noticketstodisplay']   = 'No questions to display.';
+$string['wasassigned']          = 'was assigned to this question.';
+$string['wasunassigned']        = 'was unassigned from the question.';
 $string['tagaddedwithnameof']   = 'A tag was added with the name of: ';
 $string['tagremovewithnameof']  = 'A tag was removed with the name of: ';
 $string['note']                 = 'Note';
@@ -117,12 +117,12 @@
 $string['preferencesupdated']   = 'Your preferences have been saved.';
 $string['resetonlogout']        = 'Notice: These preferences are reset when you log out.';
 $string['cannotaddassignment']  = 'Unable to add assignment.';
-$string['alltickets']           = 'All Tickets';
-$string['reportedby']           = 'Tickets reported by user';
-$string['newtickets']           = 'New Tickets';
-$string['assignedto']           = 'Tickets assigned to user';
-$string['closedtickets']        = 'Closed Tickets';
-$string['unassignedtickets']    = 'Unassigned Tickets';
+$string['alltickets']           = 'All Questions';
+$string['reportedby']           = 'Questions reported by user';
+$string['newtickets']           = 'New Questions';
+$string['assignedto']           = 'Questions assigned to user';
+$string['closedtickets']        = 'Closed Questions';
+$string['unassignedtickets']    = 'Unassigned Questions';
 $string['notes']                = 'Notes';
 $string['hideupdate']           = 'Hide Update';
 $string['hidden']               = 'Hidden';
@@ -133,29 +133,29 @@
 $string['new']                  = 'New';
 $string['inprogress']           = 'Work in progress';
 $string['closed']               = 'Closed';
-$string['statuschanged']        = 'Ticket Status Updated';
-$string['detailschanged']       = 'Ticket Details Updated';
-$string['updateticketoverview'] = 'Update Ticket Overview';
-$string['changedetails']        = 'Edit Ticket';
+$string['statuschanged']        = 'Question Status Updated';
+$string['detailschanged']       = 'Question Details Updated';
+$string['updateticketoverview'] = 'Update Question Overview';
+$string['changedetails']        = 'Edit Question';
 $string['editoverview']         = 'Edit Overview';
-$string['ticketedited']         = 'Ticket has been edited.';
+$string['ticketedited']         = 'Question has been edited.';
 $string['extrainformation']     = 'Extra Information';
 $string['updatemessage']        = 'Edit Update Notes';
 $string['cannotaddupdate']      = 'Can not add update.';
 $string['assign']               = 'User Assigned';
 $string['unassign']             = 'User Unassigned';
-$string['missingnewtickettag']  = 'Missing listed new ticket tag';
+$string['missingnewtickettag']  = 'Missing listed new question tag';
 $string['hasbeenunassigned']    = 'has been unassigned';
 $string['tag']                  = 'Tagged';
 $string['untag']                = 'Untagged';
-$string['ticketlisting']        = 'Ticket Listing';
+$string['ticketlisting']        = 'Question Listing';
 
 /**
  * These are settings.php strings.
- * These should only appear (or at least mostly,) in the helpdesk config.
+ * These should only (or at least mostly) appear in the helpdesk config.
  */
 $string['sendemailupdate']      = 'Send Email Updates';
-$string['sendemailupdatedesc']  = 'When a ticket is updated, an email will be sent to the submitter and the assigned users.';
+$string['sendemailupdatedesc']  = 'When a question is updated, an email will be sent to the submitter and the assigned users.';
 $string['emailsettings']        = 'Email Settings';
 $string['emailsettingsdesc']    = 'These settings configure the Help Desk\'s email functionality.';
 $string['emailaddr']            = 'Incoming/Outgoing Email Address';
@@ -165,7 +165,7 @@
 $string['emailpasswddesc']      = 'Password to be used for incoming email authentication.';
 $string['pluginsettings']       = 'Plugin Specific Settings';
 $string['pluginsettingsdesc']   = 'These are settings that are unique to this specific help desk plugin.';
-$string['getemailtickets']      = 'Recieve Tickets from Email';
+$string['getemailtickets']      = 'Recieve Questions from Email';
 $string['getemailticketsdesc']  = 'Parses incoming emails into the current help desk plugin. This allows user to be able
                                    send emails and have it show up in the help desk block. (UNDER CONSTRUCTION)';
 $string['emailname']            = 'Email Name';
@@ -173,37 +173,35 @@
                                    received. This should not be confused with email address.';
 $string['emailcontent']         = 'Basic Outgoing Email Body';
 $string['emailcontentdesc']     = 'Non-HTML email body that will be emailed to users who have had
-                                   one of thier tickets updated.<br />
+                                   one of thier questions updated.<br />
                                    Replacement Strings:<br />
                                    !username! : Full name of user being emailed.<br />
-                                   !ticketlink! : This is where a link back to the ticket goes.<br />
+                                   !ticketlink! : This is where a link back to the question goes.<br />
                                    !supportname! : This is the name of the support email address.<br />
                                    !updatetime! : This is the time when the email was sent.';
 $string['emailrtfcontent']      = 'Rich Text Email Body';
 $string['emailrtfcontentdesc']  = 'Rich-text (HTML) version of the update email.<br />
                                    Replacement Strings:<br />
                                    !username! : Full name of user being emailed.<br />
-                                   !ticketlink! : This is where a link back to the ticket goes.<br />
+                                   !ticketlink! : This is where a link back to the question goes.<br />
                                    !supportname! : This is the name of the support email address.<br />
                                    !updatetime! : This is the time the email was sent.';
 $string['emailsubject']         = 'Update Email Subject';
-$string['emailsubjectdesc']     = 'The subject of the email to be sent out for ticket updates.<br />
+$string['emailsubjectdesc']     = 'The subject of the email to be sent out for question updates.<br />
                                    Replacement String: !ticketid!';
-$string['emailidlewait']        = 'Idle Ticket Email Timer<br />(Experimental)';
-$string['emailidlewaitdesc']    = 'Set a duration in hours to send emails when a ticket has become idle.';
+$string['emailidlewait']        = 'Idle Question Email Timer<br />(Experimental)';
+$string['emailidlewaitdesc']    = 'Set a duration in hours to send emails when a question has become idle.';
 /**
  * These are help button strings. They are long and are required to be.
  */
-$string['helpsearch']           = 'This search phrase is a series of words that are used
-                                   to try and find a matching ticket. Tickets are search by
-                                   their summary, details, tags, and updates.';
-$string['whatarerelations']     = 'Relations determine what kind of tickets you see. These can help you navigate through large amounts of tickets and keeps your tickets organized.';
-$string['overviewhelp']         = 'The ticket overview provides a basic description about the ticket that is currently being displayed.';
-$string['assignedhelp']         = 'Assigned users are Help Desk Answers who have been assigned to help resolve a given ticket.';
-$string['taghelp']              = 'Tags are extra little bits of information that an answerer found useful and added to the ticket to make a record of it. These tags are customizable and allows an answerer to add any information that he or she sees fit.';
-$string['updatehelp']           = 'Updates reflect communication from any user who is working on a given ticket. Updates can reflect changes in a ticket as well as system updates if a user has setup their preferences to view these, they are disabled by default.';
+$string['helpsearch']           = 'This search phrase is a series of words that are used to find matching questions. Questions are searched by their summaries, details, tags, and updates.';
+$string['whatarerelations']     = 'Click a link to choose a group of questions to see. These are short-cuts to help you quickly find a question if you know something about its status or relation to you.';
+$string['overviewhelp']         = 'The question overview provides a basic description about the question that is currently being displayed.';
+$string['assignedhelp']         = 'Assigned users are Help Desk Answers who have been assigned to help resolve a given question.';
+$string['taghelp']              = 'Tags are extra little bits of information that an answerer found useful and added to the question to make a record of it. These tags are customizable and allows an answerer to add any information that he or she sees fit.';
+$string['updatehelp']           = 'Updates reflect communication from any user who is working on a given question. Updates can reflect changes in a question as well as system updates if a user has setup their preferences to view these, they are disabled by default.';
 $string['prefhelp']             = 'Preferences allows users to change how some information is presented or if any specific information is presented. Many of these settings reset after you log out.';
-$string['detailedupdateshelp']  = 'This option displays extra detail updates when viewing a specific ticket.  This includes user (un)assignments and tag removals and additions.';
+$string['detailedupdateshelp']  = 'This option displays extra detail updates when viewing a specific question.  This includes user (un)assignments and tag removals and additions.';
 $string['systemupdateshelp']    = 'This option enables you to see system updates. System updates include automatic communication and automatic actions.';
 
 ?>