=== modified file 'blocks/helpdesk/assign.php'
--- blocks/helpdesk/assign.php	2010-08-09 16:58:24 +0000
+++ blocks/helpdesk/assign.php	2010-08-17 21:16:59 +0000
@@ -47,13 +47,17 @@
 
 $context = get_context_instance(CONTEXT_SYSTEM);
 
+$baseurl = new moodle_url("$CFG->wwwroot/blocks/helpdesk/view.php");
+$returnurl = $baseurl;
+$returnurl->param('id', $tid);
 $nav = array (
     array (
-        'name' => get_string('helpdesk', 'block_helpdesk')
+        'name' => get_string('helpdesk', 'block_helpdesk'),
+        'link' => $baseurl->out()
     ),
     array (
-        'name' => get_string('viewticket', 'block_helpdesk'),
-        'link' => "$CFG->wwwroot/blocks/helpdesk/view.php?id=$tid"
+        'name' => get_string('ticketview', 'block_helpdesk'),
+        'link' => $returnurl->out()
         ),
     array (
         'name' => get_string('assignments', 'block_helpdesk')
@@ -61,13 +65,11 @@
     );
 
 helpdesk_print_header(build_navigation($nav));
-print_heading(get_string('helpdesk', 'block_helpdesk'));
+print_heading(get_string('assignments', 'block_helpdesk'));
 helpdesk_is_capable(HELPDESK_CAP_ANSWER, true);
 
 $hd = helpdesk::get_helpdesk();
 $ticket = $hd->get_ticket($tid);
-$returnurl = new moodle_url("$CFG->wwwroot/blocks/helpdesk/view.php");
-$returnurl->param('id', $tid);
 $returnurl = $returnurl->out();
 
 // What if we're removing an assignment? We want to handle that *first*.

=== modified file 'blocks/helpdesk/block_helpdesk.php'
--- blocks/helpdesk/block_helpdesk.php	2010-08-09 16:58:24 +0000
+++ blocks/helpdesk/block_helpdesk.php	2010-08-17 21:29:55 +0000
@@ -104,10 +104,6 @@
         $translated = get_string('preferences');
         $prefhelp = helpdesk_simple_helpbutton($translated, get_string('prefhelp', 'block_helpdesk'));
         $this->content->footer = "<a href=\"$url\">$translated</a>$prefhelp";
-        if ($cap) {
-            $this->content->footer .= '<br /><small>' . get_string('youarea', 'block_helpdesk') . ' ' .
-                                     get_string($cap, 'block_helpdesk') . '.</small>';
-        }
 
         return $this->content;
     }

=== modified file 'blocks/helpdesk/edit.php'
--- blocks/helpdesk/edit.php	2010-08-09 16:58:24 +0000
+++ blocks/helpdesk/edit.php	2010-08-17 21:18:39 +0000
@@ -32,11 +32,13 @@
 require_login(0, false);
 
 $id = required_param('id', PARAM_INT);
-$url = new moodle_url("$CFG->wwwroot/blocks/helpdesk/view.php");
+$baseurl = new moodle_url("$CFG->wwwroot/blocks/helpdesk/view.php");
+$url = $baseurl;
 $url->param('id', $id);
 $nav = array (
     array (
         'name' => get_string('helpdesk', 'block_helpdesk'),
+        'link' => $baseurl->out()
           ),
     array (
         'name' => get_string('ticketview', 'block_helpdesk'),
@@ -48,7 +50,7 @@
     );
 
 helpdesk_print_header(build_navigation($nav));
-print_heading(get_string('helpdesk', 'block_helpdesk'));
+print_heading(get_string('updateticketoverview', 'block_helpdesk'));
 
 $hd = helpdesk::get_helpdesk();
 

=== modified file 'blocks/helpdesk/lang/en_utf8/block_helpdesk.php'
--- blocks/helpdesk/lang/en_utf8/block_helpdesk.php	2010-08-17 19:21:59 +0000
+++ blocks/helpdesk/lang/en_utf8/block_helpdesk.php	2010-08-17 20:46:40 +0000
@@ -86,7 +86,6 @@
 $string['noneassigned']         = 'No users are assigned.';
 $string['assignuser']           = 'Assign a user';
 $string['isalreadyassigned']    = 'is already assigned to this question.';
-$string['viewticket']           = 'View Question';
 $string['notags']               = 'This question has no tags.';
 $string['changerelation']       = 'Short-cuts to question groups';
 $string['usertickets']          = 'User Questions';

=== modified file 'blocks/helpdesk/tag.php'
--- blocks/helpdesk/tag.php	2010-08-09 16:58:24 +0000
+++ blocks/helpdesk/tag.php	2010-08-17 20:46:23 +0000
@@ -53,7 +53,7 @@
 $nav = array();
 $nav[] = array ('name' => get_string('helpdesk', 'block_helpdesk'));
 $nav[] = array (
-    'name' => get_string('viewticket', 'block_helpdesk'),
+    'name' => get_string('ticketview', 'block_helpdesk'),
     'link' => $ticketurl->out()
 );
 $nav[] = array ('name' => get_string('tags', 'block_helpdesk'));

=== modified file 'blocks/helpdesk/update.php'
--- blocks/helpdesk/update.php	2010-08-09 16:58:24 +0000
+++ blocks/helpdesk/update.php	2010-08-17 21:26:29 +0000
@@ -34,11 +34,13 @@
 global $CFG;
 
 $id = required_param('id', PARAM_INT);
-$url = new moodle_url("$CFG->wwwroot/blocks/helpdesk/view.php");
+$baseurl = new moodle_url("$CFG->wwwroot/blocks/helpdesk/view.php");
+$url = $baseurl;
 $url->param('id', $id);
 $nav = array (
     array (
         'name' => get_string('helpdesk', 'block_helpdesk'),
+        'link' => $baseurl->out()
           ),
     array (
         'name' => get_string('ticketview', 'block_helpdesk'),
@@ -50,7 +52,7 @@
     );
 
 helpdesk_print_header(build_navigation($nav));
-print_heading(get_string('helpdesk', 'block_helpdesk'));
+print_heading(get_string('updateticket', 'block_helpdesk'));
 
 $hd = helpdesk::get_helpdesk();
 
@@ -73,6 +75,7 @@
         }
 }
 $form->display();
+$hd->display_ticket($ticket);
 
 print_footer();
 ?>

=== modified file 'blocks/helpdesk/view.php'
--- blocks/helpdesk/view.php	2010-08-09 16:58:24 +0000
+++ blocks/helpdesk/view.php	2010-08-17 20:58:24 +0000
@@ -41,16 +41,19 @@
 $page       = optional_param('page', null, PARAM_INT);
 $count      = optional_param('count', null, PARAM_INT);
 
-$nav = array(array ('name' => get_string('helpdesk', 'block_helpdesk')));
+$url = new moodle_url("$CFG->wwwroot/blocks/helpdesk/view.php");
+$nav = array(array (
+    'name' => get_string('helpdesk', 'block_helpdesk'),
+    'link' => $url->out()
+));
+$heading = get_string('helpdesk', 'block_helpdesk');
 if (isset($id)) {
-    $url = new moodle_url("$CFG->wwwroot/blocks/helpdesk/view.php");
-    $nav[] = array('name' => get_string('ticketlisting', 'block_helpdesk'),
-                   'link' => $url->out());
+    $nav[] = array('name' => get_string('ticketviewer', 'block_helpdesk'));
+    $heading = get_string('ticketviewer', 'block_helpdesk');
 }
-$nav[] = array ('name' => get_string('ticketview', 'block_helpdesk'));
 
 helpdesk_print_header(build_navigation($nav));
-print_heading(get_string('ticketviewer', 'block_helpdesk'));
+print_heading($heading);
 
 // Let's construct our helpdesk.
 $hd = helpdesk::get_helpdesk();