Index: moodle/blocks/activity_modules/block_activity_modules.php
--- moodle/blocks/activity_modules/block_activity_modules.php Base (1.30)
+++ moodle/blocks/activity_modules/block_activity_modules.php Locally Modified (Based On 1.30)
@@ -49,11 +49,12 @@
 
         foreach ($modfullnames as $modname => $modfullname) {
             if ($modname === 'resources') {
-                $this->content->items[] = '<a href="'.$CFG->wwwroot.'/course/resources.php?id='.$course->id.'">'.$modfullname.'</a>';
-                $this->content->icons[] = '<img src="'.$OUTPUT->pix_url('f/html') . '" class="icon" alt="" />';
+                $icon = '<img src="'.$OUTPUT->pix_url('f/html') . '" class="icon" alt="" /> ';
+                $this->content->items[] = '<a href="'.$CFG->wwwroot.'/course/resources.php?id='.$course->id.'">'.$icon.$modfullname.'</a>';
+                
             } else {
-                $this->content->items[] = '<a href="'.$CFG->wwwroot.'/mod/'.$modname.'/index.php?id='.$course->id.'">'.$modfullname.'</a>';
-                $this->content->icons[] = '<img src="'.$OUTPUT->pix_url('icon', $modname) . '" class="icon" alt="" />';
+                $icon = '<img src="'.$OUTPUT->pix_url('icon', $modname) . '" class="icon" alt="" /> ';
+                $this->content->items[] = '<a href="'.$CFG->wwwroot.'/mod/'.$modname.'/index.php?id='.$course->id.'">'.$icon.$modfullname.'</a>';
             }
         }
 
Index: moodle/blocks/course_list/block_course_list.php
--- moodle/blocks/course_list/block_course_list.php Base (1.65)
+++ moodle/blocks/course_list/block_course_list.php Locally Modified (Based On 1.65)
@@ -23,8 +23,7 @@
         $this->content->icons = array();
         $this->content->footer = '';
 
-        $icon  = "<img src=\"" . $OUTPUT->pix_url('i/course') . "\"".
-                 " class=\"icon\" alt=\"".get_string("coursecategory")."\" />";
+        $icon  = '<img src="' . $OUTPUT->pix_url('i/course') . '" class="icon" alt="" /> ';
 
         $adminseesall = true;
         if (isset($CFG->block_course_list_adminview)) {
@@ -39,8 +38,7 @@
                 foreach ($courses as $course) {
                     $linkcss = $course->visible ? "" : " class=\"dimmed\" ";
                     $this->content->items[]="<a $linkcss title=\"" . format_string($course->shortname) . "\" ".
-                               "href=\"$CFG->wwwroot/course/view.php?id=$course->id\">" . format_string($course->fullname) . "</a>";
-                    $this->content->icons[]=$icon;
+                               "href=\"$CFG->wwwroot/course/view.php?id=$course->id\">".$icon. format_string($course->fullname) . "</a>";
                 }
                 $this->title = get_string('mycourses');
             /// If we can update any course of the view all isn't hidden, show the view all courses link
@@ -59,8 +57,7 @@
             if (count($categories) > 1 || (count($categories) == 1 && $DB->count_records('course') > 200)) {     // Just print top level category links
                 foreach ($categories as $category) {
                     $linkcss = $category->visible ? "" : " class=\"dimmed\" ";
-                    $this->content->items[]="<a $linkcss href=\"$CFG->wwwroot/course/category.php?id=$category->id\">" . format_string($category->name) . "</a>";
-                    $this->content->icons[]=$icon;
+                    $this->content->items[]="<a $linkcss href=\"$CFG->wwwroot/course/category.php?id=$category->id\">".$icon. format_string($category->name) . "</a>";
                 }
             /// If we can update any course of the view all isn't hidden, show the view all courses link
                 if (has_capability('moodle/course:update', get_context_instance(CONTEXT_SYSTEM)) || empty($CFG->block_course_list_hideallcourseslink)) {
@@ -78,8 +75,7 @@
                         $this->content->items[]="<a $linkcss title=\""
                                    . format_string($course->shortname)."\" ".
                                    "href=\"$CFG->wwwroot/course/view.php?id=$course->id\">"
-                                   .  format_string($course->fullname) . "</a>";
-                        $this->content->icons[]=$icon;
+                                   .$icon. format_string($course->fullname) . "</a>";
                     }
                 /// If we can update any course of the view all isn't hidden, show the view all courses link
                     if (has_capability('moodle/course:update', get_context_instance(CONTEXT_SYSTEM)) || empty($CFG->block_course_list_hideallcourseslink)) {
@@ -110,7 +106,7 @@
             return;
         }
 
-        $icon  = '<img src="'.$OUTPUT->pix_url('i/mnethost') . '" class="icon" alt="'.get_string('course').'" />';
+        $icon  = '<img src="'.$OUTPUT->pix_url('i/mnethost') . '" class="icon" alt="" />';
 
         // shortcut - the rest is only for logged in users!
         if (!isloggedin() || isguestuser()) {
@@ -123,8 +119,7 @@
             foreach ($courses as $course) {
                 $this->content->items[]="<a title=\"" . format_string($course->shortname) . "\" ".
                     "href=\"{$CFG->wwwroot}/auth/mnet/jump.php?hostid={$course->hostid}&amp;wantsurl=/course/view.php?id={$course->remoteid}\">"
-                    . format_string($course->fullname) . "</a>";
-                $this->content->icons[]=$icon;
+                    .$icon. format_string($course->fullname) . "</a>";
             }
             // if we listed courses, we are done
             return true;
@@ -134,8 +129,7 @@
             $this->content->items[] = get_string('remotehosts', 'mnet');
             $this->content->icons[] = '';
             foreach($USER->mnet_foreign_host_array as $somehost) {
-                $this->content->items[] = $somehost['count'].get_string('courseson','mnet').'<a title="'.$somehost['name'].'" href="'.$somehost['url'].'">'.$somehost['name'].'</a>';
-                $this->content->icons[] = $icon;
+                $this->content->items[] = $somehost['count'].get_string('courseson','mnet').'<a title="'.$somehost['name'].'" href="'.$somehost['url'].'">'.$icon. $somehost['name'].'</a>';
             }
             // if we listed hosts, done
             return true;
Index: moodle/blocks/site_main_menu/block_site_main_menu.php
--- moodle/blocks/site_main_menu/block_site_main_menu.php Base (1.43)
+++ moodle/blocks/site_main_menu/block_site_main_menu.php Locally Modified (Based On 1.43)
@@ -45,15 +45,15 @@
                     } else {
                         $linkcss = $cm->visible ? '' : ' class="dimmed" ';
                         $instancename = format_string($cm->name, true, $course->id);
-                        $this->content->items[] = '<a title="'.$cm->modplural.'" '.$linkcss.' '.$cm->extra.
-                            ' href="'.$CFG->wwwroot.'/mod/'.$cm->modname.'/view.php?id='.$cm->id.'">'.$instancename.'</a>';
                         //Accessibility: incidental image - should be empty Alt text
                         if (!empty($cm->icon)) {
                             $icon = $OUTPUT->pix_url($cm->icon);
                         } else {
                             $icon = $OUTPUT->pix_url('icon', $cm->modname);
                         }
-                        $this->content->icons[] = '<img src="'.$icon.'" class="icon" alt="" />';
+                        $icon = '<img src="'.$icon.'" class="icon" alt="" /> ';
+                        $this->content->items[] = '<a title="'.$cm->modplural.'" '.$linkcss.' '.$cm->extra.
+                            ' href="'.$CFG->wwwroot.'/mod/'.$cm->modname.'/view.php?id='.$cm->id.'">'.$icon. $instancename.'</a>';
                     }
                 }
             }
@@ -130,10 +130,10 @@
                         $this->content->items[] = format_text($extra, FORMAT_HTML).$editbuttons;
                         $this->content->icons[] = '';
                     } else {
-                        $this->content->items[] = '<a title="'.$mod->modfullname.'" '.$linkcss.' '.$extra.
-                            ' href="'.$CFG->wwwroot.'/mod/'.$mod->modname.'/view.php?id='.$mod->id.'">'.$instancename.'</a>'.$editbuttons;
                         //Accessibility: incidental image - should be empty Alt text
-                        $this->content->icons[] = '<img src="'.$icon.'" class="icon" alt="" />';
+                        $icon = '<img src="'.$icon.'" class="icon" alt="" /> ';
+                        $this->content->items[] = '<a title="'.$mod->modfullname.'" '.$linkcss.' '.$extra.
+                            ' href="'.$CFG->wwwroot.'/mod/'.$mod->modname.'/view.php?id='.$mod->id.'">'.$icon. $instancename.'</a>'.$editbuttons;
                     }
                 }
             }